###########################################
#
# n-log configuration file
#
###########################################

#--------------------------#
#---- system variables ----#
#--------------------------#

# you MUST change these values to match your system

# our base directory to read the databases from
# we dont allow access to any files outside of this directory

$dbdir = "/tmp/db";

# cgi-bin directory containing nlog-search + extension scripts (rpc/smb/finger/etc)
# this path is the WEB path not the local path

$cgidir = "/cgi-bin";

# admin e-mail address (keep the ' ' quotes on it)
# if you turn security logging on it will email you whenever some
# kiddie tries to sploit the cgi's. 

$admin = 'spinux@usa.net';

# enable warning mails about attempted hacks...
#
# 0 = off, 1 = on

$hackwarn = 0;


#-------------------------#
#--- program locations ---#
#-------------------------#

#
# this is where our scripts get the full pathnames to the programs 
# they call, if you dont have a program listed here, disable its 
# extension in the 'nlog entensions and hyperlinks settings'
# section of this config file.
#


# the 'date' command
$date = "/bin/date";

# ( nlog-finger.pl )
$finger = "/usr/sbin/safe_finger";

# ( nlog-smb.pl )
$nmblookup = "/usr/bin/nmblookup";
$smbclient = "/usr/bin/smbclient";

# samba variables used in all operations
$fWORKGROUP = "WORKGROUP";
$fUSER      = "nobody";
$fNAME      = "NLOG";

#  ( nlog-rpc.pl )
$rpcinfo = "/usr/bin/rpcinfo";
$showmount = "/usr/sbin/showmount";

#  ( nlog-dns.pl )
# set to 'DISABLE' to disable this.
$nslookup = "/usr/bin/nslookup";

#-------------------------------------------------------#
#---- access remote databases via a URL for db name ----#
#-------------------------------------------------------#

# we require the LWP module to retrieve remote databases

# Using LYNX is *NOT* Safe
# its possible for anyone accessing
# your CGI to run commands on your server
# as your CGI user

# do we allow users to load remote databases
# from http URL's? [ 0 = no / 1 = yes ]
$REMOTE_DB = 1;

# using LWP to d/l the database
# have the LWP::Simple module?  [ 0 = no / 1 = yes ]
$USE_LWP = 1;


# using lynx to d/l the remote database?
# this is NOT safe, therefore disabled by default
# Use lynx and open a security hole?  [ 0 = no / 1 = yes ]
$USE_LYNX = 0;

# if yes, where is our local copy of lynx?
$lynx = "/usr/local/bin/lynx";


#-------------------------------------------------#
#---- nlog entensions and hyperlinks settings ----#
#-------------------------------------------------#

# this lets you resolve host names by clicking the ip address
$nshandler = "$cgidir/nlog-dns.pl";

# what to show as a hyperlink.. etc..
# format for 'normal' links are service+protocol ( www+http )
# each entry separated by a space, each serv/proto separated by a plus

$qlinks = "www+http telnet+telnet ftp+ftp rlogin+telnet";

# now come the cgi links...
# format is service+cgi-path+Display ( sunrpc+$cgidir/nlog-rpc.pl+SunRPC )
# the IP of the current host is sent as the query string
# the output looks like Display(ip_address) with a link to the cgi

# here we place each cgi-handler into a temp var for readability.

$cgiSunRPC = "sunrpc+$cgidir/nlog-rpc.pl+SunRPC";
$cgiSMB    = "netbios-ssn+$cgidir/nlog-smb.pl+NetBIOS";
$cgiFinger = "finger+$cgidir/nlog-finger.pl+Finger";

$qcgilinks ="$cgiSunRPC $cgiSMB $cgiFinger";

# make a couple arrays for them...

@qlinks = split(/\s/,$qlinks);
@qcgilinks = split(/\s/,$qcgilinks);

# set them all to nothing
# only data we need is @qlinks + @qcgilinks

$cgiSunRPC = '';
$cgiSMB = '';
$cgiFinger = '';
$qcgilinks = '';

#-------------------------------------#
#---- do not edit below this line ----#
#-------------------------------------#

# our version number
$version = "1.5";

# umask for all file operations
# paranoia ;)

$umask ="077";


sub printfooters {

print '<p align="center"><small><font face="Verdana">';
print "<br>n-log v$version<br>";
print 'questions, comments, or suggestions: email the author at';
print ' <a href="mailto:spinux@usa.net">spinux@usa.net</a>';
print '</font></small></p>';

}

sub checkip {

$ip = $_[0];

if ($ip =~ /^([0-9]){1,3}\.([0-9]){1,3}\.([0-9]){1,3}\.([0-9]){1,3}$/) {
         # good ip address
} else {
	
	$ourdate = `$date`;
	# evil users...
	# give them a scare message...

	print "<pre>";
	print "The address passed to this program is not a valid IP address.\n<br>";
	print "This attempt has been logged and the administrator has been notified.\n";
	print "<br><br>Date:     $ourdate\n<br>";
	print "Host:     $ENV{'REMOTE_ADDR'}\n<br>";
	print "Query:    $ip\n<br>";
	print "</pre>";
	print "</p></small></font></html>";

	if ($hackwarn eq 1) {
	
		# if hackwarn is defined, email $admin
                # !! not implemented !!		
	}	

exit 0;
}

}

sub dienice {
    ($msg) = @_;
    print "<h2>Error</h2>\n";
    print $msg;
    exit 0;
}


sub disabled {

	$back = $ENV{'HTTP_REFFERER'};

	print "Content-type: text/html\n\n";
	&printstdheader("Disabled");
	print "The function you tried to access has been disabled.\n<br>";
	print "Click <a href =\"$back\">Here</a> to go back.\n";
	&printfooters;
}

sub printstdheader {

($title) = @_;

print <<THEHEADER
<html>

<head>
<style>
<!--
A:link		{ text-decoration: none; }
A:active	{ text-decoration: none; }
A:visited	{ text-decoration: none; }
A:hover		{ COLOR = #FFFF00 }
//-->
</style>
<title>$title</title>
</head>
<body BGCOLOR="#000000" TEXT="#FFFFFF" LINK="#CCCCFF" ALINK="#FF0000" VLINK="#FF000C">

THEHEADER
;

}
