#!/usr/bin/perl
#
#
# n-log cgi db interface
#
# 
##

require "nlog-config.ph";
umask($umask);

# see how long it takes...
# thanks to Dennis Taylor
$bclock = time;
$sclock;
$tclock;

$qdatabase;

@qport;
@qstate;
@qprotocol;
@qos;
@qseqindex;

#limit amount of hosts shown
$maxhosts;
$hostcount;

$ipA;
$ipB;
$ipC;
$ipD;



#------------------------------------------------------------------

print "Content-type:text/html\n\n";

&printstdheader("n-log database query results");

print <<HEADER
<hr size="1" color="#808080">
<font face="Verdana" color="#FFFFFF"><small><strong>Results are listed below.</strong></small></font>
<hr size="1" color="#808080"><br><br>
HEADER
;

read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/, $buffer);
foreach $pair (@pairs) {
    ($name, $value) = split(/=/, $pair);
    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $FORM{$name} = $value;
}



# read our form variables

foreach $key (keys(%FORM)) {


    # Turn all empty fields into ALL
    if ($FORM{$key} eq '') {
	$FORM{$key} = 'ALL';
    }

    if ($key eq "maxhosts") {
        $maxhosts = $FORM{$key};
    }


    if ($key eq "database") {
	$qdatabase = $FORM{$key};
    }

    if ($key eq "state") {
        @qstate = split(/\s/,$FORM{$key});
    }

    if ($key eq "port") {
        @qport = split(/\s/,$FORM{$key});
    }

    if ($key eq "protocol") {
        @qprotocol = split(/\s/,$FORM{$key});
    }

    if ($key eq "os") {
        @qos = split(/\s/,$FORM{$key});
    }

    if ($key eq "seqindex") {
        @qseqindex = split(/\s/,$FORM{$key});
    }

    if ($key eq "maxhosts") {
        $maxhosts = $FORM{$key};
    }

    # Each octect of the IP address to match

    if ($key eq "ipA") {
        $ipA = $FORM{$key};
    }
    if ($key eq "ipB") {
        $ipB = $FORM{$key};
    }
    if ($key eq "ipC") {
        $ipC = $FORM{$key};
    }
    if ($key eq "ipD") {
        $ipD = $FORM{$key};
    }

}


# is our database a URL or file name?

@isurl = split('://',$qdatabase);

$isurl[0] = lc($isurl[0]);

if ($isurl[0] eq "ftp" || $isurl[0] eq "http") {
        $qdatabase = lc($qdatabase);
	$DB_TYPE = "URL";

	# make sure its allowed
	if ($REMOTE_DB ne 1) {
		&dienice("Remote database access has been disabled.");
	}

} else {

	# read as a file
	$DB_TYPE = "FILE";
}

if ($DB_TYPE eq "FILE") {

	# make sure our $qdatabase doesnt have any ..'s
	$qdatabase =~ s/\.\.//g;
	
	# open our database and loop through it by line
	open(NDB, "<$dbdir/$qdatabase") || &dienice("Can't open database: $!\n");

	# print our table headers
	&printheaders;

	# read it line by line, throw it to our processline function
	while (<NDB>){
	
	(@db_parse) = split(/\|/,$_);
	&processline;

}

close NDB;

} elsif ($DB_TYPE eq "URL") {

# load the database

	if ($USE_LWP eq 1) {
	 
	 use LWP::Simple;
	 $REMOTE_DATA = get("$qdatabase");

	} elsif ($USE_LYNX eq 1) {

         $REMOTE_DATA = `$lynx -source $qdatabase`;

	} else {

	 &dienice("No method to access remote data defined.");

	}

@NDB = split(/\n/,$REMOTE_DATA);

foreach $dataline (@NDB) {

	(@db_parse) = split(/\|/,$dataline);
	&processline;	

}

} else {

	&dienice("Unknown database type.");
}

# check our speed...
$sclock = time;
$tclock = $sclock - $bclock;

print "<br><small><font face=\"Verdana\">Spent $tclock seconds on $hostcount
hosts.<br></font></small>\n";
# Close up our html
&printfooters;
print "</body></html>";
exit 0;


sub printheaders {

print <<TABLEHEADER

<table border="0" width="100%">
  <tr>
    <td width="16%" align="center"><small><font face="Verdana"><b>ip
address</b></font></small></td>
    <td width="7%" align="center"><small><font
face="Verdana"><b>port</b></font></small></td>
    <td width="6%" align="center"><small><font
face="Verdana"><b>proto</b></font></small></td>
    <td width="10%" align="center"><small><font
face="Verdana"><b>state</b></font></small></td>
    <td width="10%" align="center"><small><font
face="Verdana"><b>service</b></font></small></td>
    <td width="1%" align="center"></td>
    <td width="7%" align="center"><small><font
face="Verdana"><b>sequence</b></font></small></td>
    <td width="42%" align="center"><small><font face="Verdana"><b>os matches</b>
</font></small></td>
  </tr>
</table>

TABLEHEADER
;
} 


sub processline {

$hostcount++;

$ch_ipaddress = $db_parse[0];
$ch_portnum = $db_parse[1];
$ch_ports = $db_parse[2];
$ch_status = $db_parse[3];
$ch_seqindex = $db_parse[4];
$ch_os = $db_parse[5];

($c_ipA,$c_ipB,$c_ipC,$c_ipD) = split(/\./,$ch_ipaddress);

@ch_ports = split(/,/,$ch_ports);

# host matching...

if ($ipA eq $c_ipA || $ipA eq "ALL") {
if ($ipB eq $c_ipB || $ipB eq "ALL") {
if ($ipC eq $c_ipC || $ipC eq "ALL") {
if ($ipD eq $c_ipD || $ipD eq "ALL") {

foreach $port (@ch_ports) {

        @ch_port  = split(/\./,$port);
        $cp_num   = $ch_port[0];
        $cp_state = $ch_port[1];
        $cp_proto = $ch_port[2];
        $cp_serv  = $ch_port[3];

	# this is a semi-logical set of loops...
	# we put the more common fields on the outside
	# to limit the number of these we actually need
	# to go through for a host/port to match.

	foreach $xport (@qport) {
	 if ($xport eq $cp_num || $xport eq $cp_serv || $xport eq "ALL" ) {

	  foreach $xstate (@qstate) {
	   if ($xstate eq $cp_state || $xstate eq "ALL") {

            foreach $xproto (@qprotocol) {
	     if ($xproto eq $cp_proto || $xproto eq "ALL") {

		#$os_match_flag = 0;              
		#foreach $xos (@qos) {

		 #@tmp_os = grep(/$xos/,$ch_os);
		 #$tmpcount = $#tmp_os;
		 #print "Count: $tmpcount -- XOS = $xos -- TMPOS = @tmp_os\n<br>";
		#}	 

		  
# Host matches all fields, start the actual output stuff.

# use tables...

$etb = "</font></small></td>";

print '<table border="0" width="100%">';

print '<tr><td width="16%"><small><font face="Verdana">';

# if we have a dns handler enabled
# make a hyperlink to the dns cgi

if ($nslookup ne "DISABLE") {
	print "<a href=\"$nshandler?$ch_ipaddress\">$ch_ipaddress</a>$etb";
} else {
	print "$ch_ipaddress$etb";
}


print '<td width="7%"><small><font face="Verdana">';
print "$cp_num$etb";

print '<td width="6%"><small><font face="Verdana">';
print "$cp_proto$etb";

print '<td width="10%"><small><font face="Verdana">';
print "$cp_state$etb";


print '<td width="10%"><small><font face="Verdana">';

# this is where we use the cgi handlers for different services
# the already_showed variable keep us from printing any port twice
# please make note of the order these are in before adding your own
# cgi handlers (having a cgi handle the 'www' service wont work until
# you remove that from the @qlinks array).

# all of these are set in nlog-config.ph


$already_showed = 0;

foreach $link (@qlinks) {
  @tmp = split(/\+/,$link);
  if ($cp_serv eq $tmp[0] && $already_showed ne 1) {
   print("<a href=\"$tmp[1]://$ch_ipaddress\">$cp_serv</a>$etb");
   $already_showed = 1;
  }
}

foreach $link (@qcgilinks) {
  @tmp = split(/\+/,$link);
  if ($cp_serv eq $tmp[0] && $already_showed ne 1) {
   print("<a href=\"$tmp[1]\?$ch_ipaddress\">$tmp[2]</a>$etb");
   $already_showed = 1 ;
  }
}

if ($already_showed ne 1) {
 print("$cp_serv$etb");
}

# finish the fields

print '<td width="1%"><small><font face="Verdana">';
print "$ch_status$etb";

print '<td width="7%"><small><font face="Verdana">';
print "$ch_seqindex$etb";

print '<td width="42%" align="center"><small><font face="Verdana">';
print "$ch_os$etb";

print '</table>';


# Close our loops, etc

	        
	      }
             }
            } 
 	   }
	  }
	 }
	}

}

#--- end of host matching


    }
   }
  }
 }

