#!/usr/bin/perl
#
#
# This script converts nmap log files (-m type)
# to a database file that can be used by the
# nlog analyzer scripts.  
#

# set our umask just to be paranoid
umask(077);

$logfile = shift;
$outfile = shift;
$version = "1.5";

# usage...
if ($logfile eq "" || $outfile eq "") {
	print "\nnlog v$version by spinux <spinux\@usa.net>\n\n";
        print "usage $0 <logfile> <dbfile>\n";

	exit 1;
}

# set the hostindex to 0
$hostindex = 0;

# open our output file
open(OUTDB, ">>".$outfile) || die "Cant open output file: $!\n";

# open our log file and loop through it by line
open(LOGDATA, $logfile) || die "Can't open log file: $!\n";
while (<LOGDATA>){

 chomp;
 # for OS type, change pipes to ' . '
 $_ =~ s/\|/' . '/g;

 # remove the commas
 $_ =~ s/\,//g;

 #split the line into fields
 (@logline) = split(/\s/,$_);
 foreach $field (@logline) {
  ($header,$entry) = split(/\:/,$field);
  #print "$header-> $entry\n";
 }


# increase the host index (host 0 does not exist!)
$hostindex++;

foreach $word (@logline) {

# these are our headers (words ending in a colon)

$cheader = "HOST" if ($word eq "Host:");
$cheader = "PORTS" if ($word eq "Ports:");
$cheader = "SEQ" if ($word eq "SeqIndex:");
$cheader = "STATUS" if ($word eq "Status:");
$cheader = "OS" if ($word eq "OS:");

# debugging stuff
# print "Header($cheader) = $word\n";

if ($cheader eq "HOST" && $word ne "Host:"  ) {

	@testvar = split('',$word);
	if ($testvar[0] ne '(' ) {
	if ($hostindex ne 0 && $word ne '()') {

	print( OUTDB "$hostname|$portindex|");
	for($item=0;$item<=$portindex;$item++)  {
		
		if ($item ne 0) {
			print  OUTDB "$myports[$item]";
		
		if ($item ne $portindex) {
			print  OUTDB ",";
		}
	        }
	}
	
	# remove any spaces from the status response
        $Status =~ s/\s//g;

	print( OUTDB "|$Status|$SeqIndex|$OS\n");
	}

	# reinitialize host variables

	$portindex = 0;
	@myports;
	$myports[0]="";
	$hostname = "";
        $OS = "";
	$SeqIndex = "";
	$Status = "";

	if ($word ne '()') {
	$hostname = $word;
	}
}
}

if ($cheader eq "PORTS" && $word ne "Ports:"  ) {

	(@theport) = split(/\//,$word);
	if ($theport[0] > 0 && $theport[0] < 65536 ) {
		$service = getservbyport($theport[0], $theport[2]);

		if ($service eq ''){
			$service = "unknown";
		}

		$theport[3] = $service;
		$portindex++;

		$myports[$portindex] = "$theport[0].$theport[1].$theport[2].$theport[3]";
		# stored in format: port.state.protocol.service
	}
}

# Sequence Number Index
if ($cheader eq "SEQ" && $word ne "SeqIndex:"  ) {
	$SeqIndex = $word;
}

# Operating System 
if ($cheader eq "OS" && $word ne "OS:"  ) {
        $OS = "$OS $word";
}

# Status
if ($cheader eq "STATUS" && $word ne "Status:"  ) {
        $Status = "$Status $word";
}

}

# close and cleanup
}
close LOGDATA;
close OUTDB;


print "\nnlog v$version by spinux <spinux\@usa.net>\n\n";
print "read $hostindex hosts from $logfile.\n";

exit 0;
